from fix_gltf_bam import render_stage_convert
from panda3d.core import AmbientLight, DirectionalLight, NodePath

from direct.showbase.ShowBase import ShowBase

class MyApp(ShowBase):

    def __init__(self):
        ShowBase.__init__(self)

        #model = loader.load_model("untitled.gltf")
        model = loader.load_model("abstractroom.gltf")
        
        render_stage_convert(model)
        model.reparent_to(render)

        sun = DirectionalLight("sun")
        sun.set_color((0.8, 0.8, 0.8, 1))
        
        sun_np = NodePath(sun)
        sun_np.reparent_to(render)
        
        sun_np.set_z(50)
        sun_np.set_x(40)
        sun_np.set_y(-40)
        sun_np.set_p(-40)
        sun_np.set_h(45)

        sun_np.node().set_shadow_caster(True, 1024, 1024)
        sun_np.node().get_lens().set_film_size(20, 20)
        #sun_np.node().get_lens().setNearFar(10, 100)
        #sun_np.setDepthOffset(1)
        #sun_np.node().get_lens().setFov(40)
        sun_np.node().show_frustum()
        render.set_light(sun_np)

        ambient = AmbientLight('alight')
        ambient.set_color((0.5, 0.5, 0.5, 1))
        ambient_np = NodePath(ambient)
        ambient_np.reparent_to(render)
        render.set_light(ambient_np)
        render.set_shader_auto()

app = MyApp()
app.run()

